#!/usr/bin/perl

$gBaseURL = "./";
$gBaseDIR = "./";
$gIconURL = "./images";
$gCGI_URL = "./memo.cgi";

$gMakeBoard = "Y";
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    if($FORM{'id'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'id'}";
        $gNumFile = "$FORM{'id'}.num";
        $gCfgFile = "$FORM{'id'}.cfg";
        $gPwdFile = "$FORM{'id'}.pwd";
        $gDatFile = "$FORM{'id'}.idx";
    }
    else {
        &HTMLHeader;
        print "<hr noshade width=300>\n";
        print "ũϴ  $gCGI_URL?id=<font  size=-2 color=#ff0000>DB ̸</font><br>\n";
        print "<hr noshade width=300><p>\n";
        &HTMLFooter;
    }
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gMakeBoard eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
            print "<hr noshade width=300>\n";
            print "ڿ  ޸  Ǿϴ<br>\n";
            print "<hr noshade width=300><p>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getNumber;
    &getEnvVar;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }
    if($FORM{'action'} eq "r") {	
	&readData;
    } 
    elsif($FORM{'action'} eq "write") {
	&writeData;
    } 
    elsif($FORM{'action'} eq "write2") {
    &checkAdminPassword;
	&writeData2;
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
	&deleteData;
    } 
    elsif($FORM{'action'} eq "admin_input_form") {
       &checkAdminPassword;
        &showAdminInputForm;
    }
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "config_form") {
       &checkAdminPassword;
       &showConfigForm;
	}
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    else {
        exit;
    }
}

sub getNumber {
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);

        open(HANDLE,"<$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        if($gNoOfData != $#datum) {
            $gNoOfData = $#datum;
            &putNumber;
        }
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/messages",0777);

        open(HANDLE,">$gBaseDIR/$gDatFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImage = $datum[2];

        $gTableCell = $datum[3];
        $gTableText = $datum[4];

        $gTableWidth = $datum[5];
        $gRecPerPage = $datum[6];

		$gImpText = $datum[7];
		$gDateText = $datum[8];
		$gNameText = $datum[9];

        $gTextColor = $datum[10];
        $gButtonOver = $datum[11];
        $gButtonOut = $datum[12];

        $gAdminOnly = $datum[13];
        $gTagUse = $datum[14];
        $gMemoLength = $datum[15];
        $gListHover = $datum[16];

        chop($gHomeImageURL);
    }
    else {
        $gBackColor = "#ffffff";
        $gBackImage = "";
        $gTextColor = "#FF5CAD";
        $gTableCell = "#ffffff";
        $gTableText = "#FF5CAD";
        $gTableWidth = "550"; 
        $gRecPerPage = "22";
		$gImpText = "#FF5CAD";
		$gDateText = "#FF5CAD";
		$gNameText = "#FF5CAD";
        $gButtonOver = "#ffffff";
        $gButtonOut = "#ffffff";
        $gAdminOnly = "NO";
        $gTagUse = "NO";
        $gMemoLength = "30";
        $gListHover = "";

        &putEnvVar;
    }
}
 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImage|$gTableCell|$gTableText|$gTableWidth|$gRecPerPage|$gImpText|$gDateText|$gNameText|$gTextColor|$gButtonOver|$gButtonOut|$gAdminOnly|$gTagUse|$gMemoLength|$gListHover|\n";
    close(HANDLE);
}

sub readData {
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &HTMLHeader;
    &showInputForm;
    &readIndexFile;
    &HTMLFooter;
}

sub readIndexFile {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
$short_subject = $value[2];
$short_date= $value[5];

if($i%2) {
print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0><tr><td>\n";
}
else {
print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0><tr><td>\n";
}

print "<table width=100% border=0 cellspacing=0 cellpadding=0 style=\padding-top:4; padding-bottom:4\">\n";
print "<tr bgcolor=$gTableCell onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor=''><td width=100%><table border=0 cellspacing=0 cellpadding=0 width=100% align=left ><tr><td align=left width=70>\n";
print "<a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/delete.gif border=0 align=absmiddle alt=delete></a>  <font color=$gNameText>$value[3]</font></td>\n";
print "<td><img src=$gIconURL/pen.gif align=absmiddle> <font color=$gTableText>$short_subject</font></a></td><td width=75 align=right style=\"padding-bottom:5px;\"><font face=tahoma size=1 color=$gDateText>[$short_date]</font></td></tr></table></td></tr></table></td></tr>\n";
print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr></table>\n";
}
}
    unless($gNoOfData) {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=6>\n";
        print "<tr align=center><td> ޸ ϴ.^^ ۸ ּ\n";
        print "</table>\n";
    }
&MenuButton;
}

sub MenuButton {
    local($prev_page,$next_page);
    print "<table border=0 cellspacing=0 cellpadding=0 width=$gTableWidth>\n";
    print "<tr><td colspan=99><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "<tr><td><table border=0 cellspacing=0 cellpadding=0 width=100% style=\padding-top:2; padding-bottom:2\"><tr bgcolor=$gTableCell><td>";
    if ($gCurPage == 1) {
    print "<font style=\"color:$gNameText;font-size:7pt\"> </font>\n";
    }
    else {
    $prev_page = $gCurPage-1;
    print "&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$prev_page><font style=\"font-size:7pt\"></font></a> \n"
    }
    if($gCurPage eq $gTotPage) {
    print "<font style=\"color:$gNameText;font-size:7pt\"> </font>\n";
    }
    else {
        $next_page = $gCurPage+1;
    print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$next_page><font style=\"font-size:7pt\"></font></a>\n"
    }
    ###Ʒ  ΰ κп ؼ ϰų  !###
    print "</td><td align=center><a href=http://soback.kornet21.net/~zeusso title=\" creat \" target=_blank><font style=\"font-size:8pt;font-face:Verdana\">wonie</font></a><font style=\"color:$gNameText;font-size:7pt\"> / </font><a href=http://www.khim.pe.kr/ title=\" modify \" target=_blank><font style=\"font-size:8pt;font-face:Verdana\">khim</font></a><font style=\"color:$gNameText;font-size:7pt\"> / </font><a href=http://pje444.com/ title=\"Ἥ \" target=_blank><font style=\"font-size:8pt;font-face:Verdana\">Skin by </font></a></td><td align=right>\n";
    print "<a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form><img src=$gIconURL/login.gif border=0></a></td></tr></table>\n";
    print "</td></tr></table>\n";
}

sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<head>\n";
    print "<title> memo </title>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
    print "<style>\n";
    print "<!--\n";
    print " body,td   {font-size:9pt;color:$gTextColor}\n";
    print " div       {line-height:0.7cm}\n";
    print " a:link    {color :$gNameText; text-decoration:none}\n";
    print " a:visited {color :$gNameText; text-decoration:none}\n";
    print " a:active  {color :$gDateText; text-decoration:none}\n";
    print " a:hover   {color :$gDateText; text-decoration:underline}\n";
    print "-->\n";
    print "</style>\n" ;
	print "<style type=text/css>\n";
	print "body\n";
	print "{scrollbar-face-color: #ffffff; scrollbar-shadow-color: #ffffff;\n";
	print "scrollbar-highlight-color: #ffffff; scrollbar-3dlight-color: #ffffff;\n";
	print "scrollbar-darkshadow-color: #ffffff; scrollbar-track-color: #ffffff;\n";
	print "scrollbar-arrow-color: #0072bc}\n";
	print "</style>\n";	
	print "<script language=\"JavaScript\">\n";
    print " function nextWin(){\n";
    print "  location = \"$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\"\n";
    print "}\n";
    print "</script>\n";
    print "<script language=javascript>\n";
    print " function clearField(field){\n";
    print "  if (field.value == field.defaultValue) {\n";
    print "   field.value = '';\n";
    print " }\n";
    print "}\n";
    print " function checkField(field){ \n";
    print "  if (field.value == '') {\n";
    print "   field.value = field.defaultValue;\n";
    print " }\n";
    print "}\n";
    print "</script>\n";
	print "</head>\n";

    if($gDelayTime == 0) {
        if($gBackImage) {
            print "<body background=$gBackImage>\n";
        }
        else {
            $gBackColor = "#ffffff" unless($gBackColor);
            print "<body bgcolor=$gBackColor>\n";
        }
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>\n";
        if($gBackImage) {
            print "<body background=$gBackImage>\n";
        }
        else {
            $gBackColor = "#ffffff" unless($gBackColor);
            print "<body bgcolor=$gBackColor>\n";
        }
    }
    print "<center>\n";
}

sub HTMLFooter {
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

sub PageFooter {
    print"\n";
}

sub showInputForm {
    local($data,$subject,$name,$value);
    local(@value,@cookies);
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }

    print "<table border=0 cellspacing=0 cellpadding=0 width=$gTableWidth>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "<tr><td>\n";
    print "<table width=100% cellpadding=1 cellspacing=0 border=0>";
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";

if ($gAdminOnly eq "YES"){
        print "<input type=hidden name=action value=write2>\n";
        print "<input type=hidden name=oldpasswd maxlength=8>\n";}
else {
        print "<input type=hidden name=action value=write>\n";
        print "<input type=hidden name=passwd maxlength=8>\n";
}

    print "\n";
    print "<tr align=left bgcolor=$gTableCell><td><font face=tahoma size=1≯ :</font>&nbsp<input name=name type=text size=8 maxlength=4 style='background-color:$gButtonOut;font-size:9pt;color:$gTextColor;border:$gTextColor; border-style:none; height:15px' onblur=checkField(this) onfocus=clearField(this)>\n";
	print "<font face=tahoma size=1>޸ :</font>&nbsp<input name=subject type=text size=40 maxlength=$gMemoLength style='background-color:$gButtonOut;font-size:9pt;height:15px;color:$gTextColor;border:$gTextColor border-style:none' onblur=checkField(this) onfocus=clearField(this)>\n"; 
	print "</td><td align=right><input type=submit value=\"write\" style=\"font-size:8pt; font-face=tahoma; height:14px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\"></td></tr>\n";
    print "</table></td></tr>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "<input type=hidden name=html value=enable checked>\n";
    print "</table>\n";
}

sub showAdminInputForm {
    local($data,$subject,$name,$value);
    local(@value,@cookies);
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }

&HTMLHeader;

	print "<p><br><br>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 width=350>\n";
	print "<tr><td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td>\n";
	print "<td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td>\n";
	print "<td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td></tr>\n";
	print "<tr><td background=$gIconURL/dot_cross.gif width=1><img src=_cl.gif width=1 border=0></td>\n";

    print "<td><table width=348 border=0 cellsapcing=0 cellpadding=5>\n"; 
	print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";
    print "<input type=hidden name=action value=write2>\n";
    print "<tr><td align=left>  ȣ <input type=password name=oldpasswd size=15 maxlength=8 style=\"height:18px;background-color:$gButtonOut;border:1 solid $gTextColor\"></td></tr>\n";
    print "<tr><td align=left> ̸  <input name=name value=\"$COOKIE{'UN'}\" type=text size=15 maxlength=10 style=\"height:18px;background-color:$gButtonOut;border:1 solid $gTextColor\"></td></tr>\n";
	print "<td align=left> ޸  <input name=subject type=text size=30 maxlength=$gMemoLength style=\"height:18px;background-color:$gButtonOut;border:1 solid $gTextColor\"> \n";
	print "<input type=submit value= style=\"font-size:9pt;height:18px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\"></td></tr>\n";
    print "<input type=hidden name=html value=enable checked>\n";
    print "</table></td>\n";

	print "<td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td></tr>\n";
	print "<tr><td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td>\n";
	print "<td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td>\n";
	print "<td background=$gIconURL/dot_cross.gif><img src=$gIconURL/_cl.gif width=1 border=0></td></tr>\n";
	print "</table>\n";

&HTMLFooter;

}

sub writeData {
    &getNumber;
    &getVariable;
    print "Set-Cookie: UN=$name; expires=Sunday, 12-Dec-1999 12:12:12 GMT;\r\n";

    &makeCryptPassword if($passwd);
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
    print "<br><br>\n";
    print "<hr noshade width=300>\n";
    print "޸ ּż մϴ.^^*~<br><br>\n";
    print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>  Ŭϼ.~@</a>\n";
    print "<hr noshade width=300>\n";
    &PageFooter;
    &HTMLFooter;
}

sub writeData2 {
    &getNumber;
    &getVariable;
    print "Set-Cookie: UN=$name; expires=Sunday, 12-Dec-1999 12:12:12 GMT;\r\n";

    &makeCryptPassword if($passwd);
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
    print "<br><br><hr noshade width=300>\n";
    print "<font color=$gImpText>޸ ּż մϴ.</font><br><br>\n";
    print "ڵ ưϴ. ø ٸ.\n";
    print "<hr noshade width=300>\n";
    print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]<br>\n";
    &PageFooter;
    &HTMLFooter;
}

sub getVariable {
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }

    unless($FORM{'name'} =~ /^\s*$/) {
        $name = "$FORM{'name'}";
        $name =~ s/\|/&#124;/g;
    }
    else {
        &error(no_name);
    }

    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        if ($gTagUse eq "NO") {
            $subject =~ s/</&lt;/g;
            $subject =~ s/>/&gt;/g;
            $subject =~ s/"/&quot;/g;
            $subject =~ s/\|/&#124;/g;
        }
        $subject =~ s/\|/&#124;/g;
    }
    else {
        &error(no_subject);
    }
    
    &getDate;
}

sub getDate {     
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    if($sec < 10) {
        $sec = "0$sec";
    }
    if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }

    $date = "$mon/$mday $hour:$min:$sec";
    $d = "$mon$mday";
}  

sub downData {
    &addHitCounter($FORM{'file'});

    print "Content-Type: application/octet-stream\n";
    print "Content-Disposition: attachment; filename=$FORM{'file'}\n\n";
    open(HANDLE,"<$gBaseDIR/files/$FORM{'file'}");
        binmode(HANDLE);
        binmode(STDOUT);
        binmode(STDERR);
        print <HANDLE>;
    close(HANDLE);
    exit;
}

sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
    local(@set);

    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/messages/$gRandomFilename.txt");
        print HANDLE "$gCryptPassword|$gRandomFilename|$name|$date|$subject|\n";
    close(HANDLE);
}

sub appendIndexFile {
    local($data);
    local(@datum,@point);

    &lock;
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
        print HANDLE "$thread|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

sub error {
    local($error) = $_[0];
    
    &HTMLHeader;
    if($error eq "no_name") {
        print "<br><br><hr noshade width=300>\n";
        print "̸ ݵ ؾ մϴ<br>\n";
        print "<hr noshade width=300>\n";
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
    }
    elsif($error eq "no_subject") {
        print "<br><br><hr noshade width=300>\n";
        print "޸  ݵ ؾ մϴ<br>\n";
        print "<hr noshade width=300>\n";
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
    }
    &HTMLFooter;
}

sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";

    print "<br><br> йȣ Էϼ<br>\n";
    print "<input type=password name=passwd size=25 maxlength=8 style=\"background-color:$gButtonOut;border:1 solid $gTextColor\">\n";
    print "<br><br><input type=submit value=ϱ style=\"font-size:9pt;height:18px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\">\n" if($command eq "delete");
    print "<br><br><input type=submit value=ϱ style=\"font-size:9pt;height:18px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\">\n" if($command eq "show_update_form");
    print "</form>\n";
    &HTMLFooter;       
}

sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<br><br><hr noshade width=300>\n";
        print " йȣ ġ ʽϴ\n";        
        print "<hr noshade width=300>\n";
        print "</form><p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]\n";
        &HTMLFooter;
    } 
    
}

sub deleteData {
    local($delete_filename);
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
        else {
            $delete_filename = $value[7];
        }
    }
    close(HANDLE);

    unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
    unlink("$gBaseDIR/files/$delete_filename");
    &getNumber;
    $gNoOfData--;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
    print "<br><br><hr noshade width=300>\n";
    print "׸  Ǿϴ\n";
    print "<hr noshade width=300>\n";
    print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]<br>\n";
    &HTMLFooter;
}

sub showAdminLogin {
	local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<form action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print " йȣ ϼ(ʱ Դϴ)<br>\n";
        print " йȣ <input type=password name=newpasswd size=20 maxlength=8 style=\"background-color:$gButtonOut;border:1 $gTextColor solid\"><br>\n";
        print "йȣ Է <input type=password name=repasswd size=20 maxlength=8 style=\"background-color:$gButtonOut;border:1 $gTextColor solid\"><br><br>\n";
        print "<input type=submit value=ϱ style=\"font-size:9pt;height:18px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\">\n";
        print "</form>\n";
    }
    else {
        print "<form method=post action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<br><br> йȣ Էϼ\n";
        print "<br><input type=password name=oldpasswd size=25 maxlength=8 style=\"background-color:$gButtonOut;border:1 $gTextColor solid\"><br>\n";
 		print "<select name=action>";
        print "<option value=$FORM{'c'} selected> α";
        print "<option value=admin_input_form> ۾";
        print "</select>\n";

        print "<br><br><input type=submit value=ϱ style=\"font-size:9pt;height:18px;color:$gTextColor;background-color:$gButtonOut;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gButtonOver'\" onMouseOut=\"this.style.backgroundColor='$gButtonOut'\">\n";
        print "</form>\n";
    }
    &HTMLFooter;
    close(HANDLE);
}
 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<br><br><hr noshade width=300>\n";
                print " йȣ Է ʾҽϴ\n";
                print "<hr noshade width=300>\n";
                print "</form><p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]\n";

                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=300>\n";
            print " йȣ ġ ʽϴ\n";
            print "<hr noshade width=300>\n";
            print "</form><p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]\n";
            &HTMLFooter;
        } 
    } 

    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        if ($gAdminOnly eq "YES"){
          unless ($old_password eq $save_password) {
              &HTMLHeader;
              print "<br><br><hr noshade width=300>\n";
              print " йȣ ġ ʽϴ<br>\n";
              print "ڸ ۾Ⱑ մϴ.\n";
              print "<hr noshade width=300>\n";
              print "</form><p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]\n";
              &HTMLFooter;
          }
         }
        else {
          unless ($old_password eq $save_password) {
              &HTMLHeader;
              print "<br><br><hr noshade width=300>\n";
              print " йȣ ġ ʽϴ\n";
              print "<hr noshade width=300>\n";
              print "</form><p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>ư</a>]\n";
              &HTMLFooter;
          }
         }
    }
}

sub checkConfigPassword {
    local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    local(@set);
 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br><br><hr noshade width=300>\n";
            print "ȯ  Ȯ   йȣ ġ ʽϴ.\n";
            print "<hr noshade width=300>\n";
	        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
            &HTMLFooter;
        }
}

sub showConfigForm {
    &HTMLHeader;
 print "<tr><td colspan=2 align=center><font color=#0072bc><b><br>Ἥ񽺴 http://pje444.com  ûϼ</b><br></font></td></tr>\n";
    print "<table width=450 border=0 cellspacing=0 cellpadding=4><tr><td><b> ȣ </b></td></tr></table>";
    print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#0072bc><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";    
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";
	
    print "<tr><td>ο йȣ</td><td align=right> <input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>йȣ Է</td><td align=right> <input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>\n";
    if($gMakeBoard eq "Y") {
        $gMakeBoard = "";
    } 
    else {
        $gMakeBoard = "";
    }
	print "<tr><td align=right>޸ ߰:</td><td><font color=#0072bc size=-1><b>$gMakeBoard</b></font></td></tr>\n";
	print "</table></td></tr></table>\n";

    print "<p><table width=450 border=0 cellspacing=0 cellpadding=4><tr><td><b>⺻ ȯ </b></td></tr></table>";
    print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#0072bc><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";    
    print "<tr><td>޸ </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10 class=ad></td></tr>\n";
	print "<tr><td colspan=2 align=center><font color=#0072bc><b>% </b>  ϴ.</font></td></tr>\n";
    print "<tr><td></td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10 class=ad></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=30 class=ad></td></tr>\n";
	print "</table></td></tr></table>";
    print "<p><table width=450 border=0 cellspacing=0 cellpadding=4><tr><td><b>۸ ⺻ ȯ </b></td></tr></table>";
    print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#0072bc><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";    
    print "<tr><td>⺻  </td><td align=right><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td>  </td><td align=right><input type=text name=TableCell value=\"$gTableCell\" size=10></td></tr>\n"; 
	print "<tr><td>  </td><td align=right><input type=text name=TableText value=\"$gTableText\" size=10>\n";
    print "<tr><td>߿ ؽƮ </td><td align=right><input type=text name=ImpText value=\"$gImpText\" size=10></td></tr>\n";
    print "<tr><td>¥ κ </td><td align=right><input type=text name=DateText value=\"$gDateText\" size=10></td></tr>\n";
    print "<tr><td≯ κ </td><td align=right><input type=text name=NameText value=\"$gNameText\" size=10></td></tr>\n";
    print "<tr><td>ư  [onMouseOver]</td><td align=right><input type=text name=ButtonOver value=\"$gButtonOver\" size=10></td></tr>\n";
    print "<tr><td>ư  [onMouseOut]</td><td align=right><input type=text name=ButtonOut value=\"$gButtonOut\" size=10></td></tr>\n";
    print "<tr><td>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10></td></tr>\n";
    print "<tr><td>޸ </td><td align=right><input type=text name=MemoLength value=\"$gMemoLength\" size=10></td></tr>\n";
    print "<tr><td>ListHover </td><td align=right><input type=text name=ListHover value=\"$gListHover\" size=10></td></tr>\n";
	print "</table></td></tr></table>";

    print "<p><table width=450 border=0 cellspacing=0 cellpadding=4><tr><td><b>  </b></td></tr></table>";
    print "<table width=450 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#0072bc><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";  
    print "<tr><td>HTML </td><td align=right><select name=TagUse>";
    if($gTagUse eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>";
    }
    print "</select></td></tr>\n";
    print "<tr><td>ڸ ۾</td><td align=right><select name=AdminOnly>";
    if($gAdminOnly eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>";
    }
    print "</select></td></tr>\n";
	print "</table></td></tr></table>";

    print "<p>\n";
    print "<input type=submit value=ϱ style=\"font-size:10pt;height:19px;color:$gTextColor;background-color:#e3e3e3;border:1 solid $gTextColor;cursor: hand\" onMouseOver=\"this.style.backgroundColor='#f3f3f3'\" onMouseOut=\"this.style.backgroundColor='e3e3e3'\">\n";
    print "</form>\n";
    &HTMLFooter;
}

sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");

    $gTableCell = $FORM{'TableCell'};
    $gTableText = $FORM{'TableText'};

	$gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);

	$gImpText = $FORM{'ImpText'};
	$gButtonOver = $FORM{'ButtonOver'};
	$gButtonOut = $FORM{'ButtonOut'};

    $gDateText = $FORM{'DateText'};
	$gNameText = $FORM{'NameText'};

	$gMemoLength = $FORM{'MemoLength'};
    $gListHover = $FORM{'ListHover'};
    $gTagUse = $FORM{'TagUse'};
    $gAdminOnly = $FORM{'AdminOnly'};

    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}
